<template>
  <section class="plan">
    <div class="plan__wrapper">
      <header class="plan__name">{{ plan.name }}</header>
      <ul class="plan__feature-list">
        <li v-for="(feature, i) in plan.features" :key="i" class="plan__feature">{{ feature }}</li>
      </ul>
      <label class="button plan__button">
        <!-- button animation markup -->
        <div class="button__border-top"></div>
        <div class="button__border-right"></div>
        <div class="button__border-bottom"></div>
        <div class="button__border-left"></div>
        <!-- /button animation markup -->
        <div class="button__inner">
          <!-- let parent handle all interacion with the store so the component is isolated -->
          <input
            class="button__input"
            @change="$emit('choosePlan')"
            type="radio"
            name="planChoice"
            :value="plan.id"
          />
          Elegir régimen
          <span class="button__radio"></span>
        </div>
      </label>
    </div>
  </section>
</template>

<script>
export default {
  name: 'Plan',
  props: {
    plan: Object,
  },
};
</script>

<style lang="scss" scoped>
// We implement a respnsive flexible layout where columns don't shrink past 200px,
// they wrap into the next row instead
.plan {
  display: flex;
  flex: 1 1 200px; // So the columns will take all avaiable space in each row
  flex-direction: column;
  -ms-flex-direction: row; // For IE11
  align-items: center; // So a column that wraps and takes a full row still looks good
  -ms-flex-align: stretch; // // For IE11
  margin: 6px;
  padding: 0 15px;
  transition: border-color 0.2s ease-in-out;
  border: $secondary-border;
  background-color: white;

  &:hover {
    border-color: $primary-dark;
  }
}

.plan__wrapper {
  display: flex;
  flex: 1;
  flex-direction: column;
}

.plan__name {
  @extend %flex-center;

  @include font-roboto-bold(null, $primary-medium);
  position: relative;
  height: 60px;
  text-align: center;

  // This is the partial line placed below each plan__name
  &::before {
    $line-length: 35%;
    content: '';
    position: absolute;
    bottom: 0;
    left: calc((100% - #{$line-length}) / 2); // centers the line
    width: $line-length;
    height: 1.5px;
    border-bottom: $secondary-border; // the line itself
  }
}

.plan__feature-list {
  @include font-roboto(0.937rem, $primary-dark);
  margin-bottom: 50px;
  padding-left: 15px;
  list-style: none;
}

.plan__feature {
  margin-bottom: 0.5em;

  // Custom bullet points
  &::before {
    content: '\2022';
    display: inline-block;
    width: 1em;
    margin-left: -1em;
    color: #a0a0a0;
    font-weight: bold;
  }
}

.button {
  position: relative;
  margin-top: auto;
  margin-bottom: 20px;
  padding: 15px;
  transition: transform 0.2s ease-out;
  border: 1px solid transparent;
  background-color: $background-light;
  cursor: pointer;

  &:active {
    transform: scale(0.9);
  }

  /* ------- BUTTON HOVER ANIMATION ------- */
  %button-border {
    position: absolute;
    background: $primary-dark;
  }

  %border-top-bottom {
    @extend %button-border;
    width: 0;
    height: 1px;
    transition: width ease-in-out 0.3s;
  }

  %border-right-left {
    @extend %button-border;
    width: 1px;
    height: 0;
    transition: height 0.3s ease-in-out 0.3s;
  }

  &__border-top {
    @extend %border-top-bottom;
    top: 0;
    left: 0;
  }

  &__border-bottom {
    @extend %border-top-bottom;
    right: 0;
    bottom: 0;
  }

  &__border-right {
    @extend %border-right-left;
    top: 0;
    right: 0;
  }

  &__border-left {
    @extend %border-right-left;
    bottom: 0;
    left: 0;
  }

  &:hover &__border-top,
  &:hover &__border-bottom {
    width: 100%;
  }

  &:hover &__border-right,
  &:hover &__border-left {
    height: 100%;
  }
}

/* ------- CUSTOM RADIO BUTTONS ------- */
.button__inner {
  position: relative;
}

.button__input {
  opacity: 0;
}

// radio outer circle
.button__radio {
  position: absolute;
  top: 3px;
  left: 0;
  width: 15px;
  height: 15px;
  border: 1px solid $gray-text;
  border-radius: 50%;
  background-color: white;

  .button__input:checked ~ & {
    border-color: $green;
  }

  // radio inner circle
  &::after {
    content: '';
    display: none;
    position: absolute;
    top: 2px;
    left: 2px;
    width: 9px;
    height: 9px;
    border-radius: 50%;
    background: $green;
  }

  .button__input:checked ~ &::after {
    display: block;
  }
}
</style>
